<template>
  <q-input-frame
    class="q-input"

    :stack-label="stackLabel"
    :float-label="floatLabel"
    :hide-underline="hideUnderline"
    :color="color"

    :focused="focused"
    :length="length"

    @click="onFocus"
    @focus="onFocus"
  >
    <input
      ref="autocomplete"
      class="col q-input-target q-no-input-spinner"
      :placeholder="placeholder"
      v-model="model"
      @focus="onFocus"
      @blur="onBlur"
    />
  </q-input-frame>
</template>

<script>
  export default {
    name: 'GoogleAutocomplete',
    props: {
      value: {
        type: String,
        required: true,
      },
      placeholder: {
        type: String,
        default: '',
      },
      stackLabel: String,
      floatLabel: String,
      hideUnderline: Boolean,
      color: {
        type: String,
        default: 'primary',
      },
      types: {
        type: String,
        default: 'address',
      },
      country: [String, Array],
      enableGeolocation: Boolean,
    },

    data() {
      return {
        model: this.value,
        autocomplete: null,
        focused: false,
      };
    },

    watch: {
      value(v) {
        this.model = v;
      },
      country() {
        this.autocomplete.setComponentRestrictions({
          country: this.country === null ? [] : this.country,
        });
      },
    },
    mounted() {
      const el = this.$refs.autocomplete;
      const options = {
        types: [this.types],
      };

      if (this.country) {
        options.componentRestrictions = {
          country: this.country,
        };
      }

      this.autocomplete = new this.$maps.places.Autocomplete(
        el,
        options,
      );

      this.autocomplete.addListener('place_changed', () => {
        const place = this.autocomplete.getPlace();

        if (!place.geometry) {
          this.$emit('no-results-found', place);
          return;
        }

        this.$emit('placechanged', place);

        this.model = el.value;
      });
    },
    computed: {
      length() {
        return this.model.length;
      },
    },
    methods: {
      onFocus() {
        this.focused = true;
        this.geolocate();
      },
      onBlur() {
        this.focused = false;
      },
      geolocate() {
        if (this.enableGeolocation && navigator.geolocation) {
          navigator.geolocation.getCurrentPosition((position) => {
            const geolocation = {
              lat: position.coords.latitude,
              lng: position.coords.longitude,
            };
            const circle = new this.$maps.Circle({
              center: geolocation,
              radius: position.coords.accuracy,
            });
            this.autocomplete.setBounds(circle.getBounds());
          });
        }
      },
    },
  };
</script>
